/*------------------------------------------------------------
TEAM20
A
159
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define SIZE 17

typedef enum {XN,XV,ON,OV,E,F};

typedef struct __list {
  int x;
  __list *next;
} _list;

_list *moves,*vets,*cvets,*legs,*clegs,*quiet,*cquiet;

char pos[(SIZE+2)*(SIZE+2)];

char was[(SIZE+2)*(SIZE+2)];

int cnt_mov;

int del[4];

int col,op_col;

int pos_val[2];

int city[2];

int N;

_list data[100000];
int used;

inline void add_mov(_list **start,_list **end,int l) {
		if(*end) {
			(*end)->next=&data[used++];
			*end=(*end)->next;
		} else {
			(*end)=&data[used++];
		}
          if(!(*start)) (*start)=(*end);
          (*end)->x=l;
          (*end)->next=0;
}

void wav(int k) {
  int l,q_old,q_new,prv,nxt,front[2][(SIZE+2)*(SIZE+2)];
  int zdel[4]; char t[4];
  memset(t,0,sizeof(t));

  for(int i=0;i<4;i++) {
    int j;
    do {
      j=rand()&3;
    } while(t[j]);
    t[j]=1;
    zdel[i]=j;
  }

  q_old=1; prv=0;
  front[0][0]=k;
  was[k]=1;
  do { q_new=0; nxt=prv^1;
    for(int j=0;j<q_old;j++) {
      k=front[prv][j];
      for(i=0;i<4;i++) {
        l=k+del[zdel[i]];
        if(pos[l]!=F && !was[l]) {
          if((pos[l]>>1)==col) {
            was[l]=1; front[nxt][q_new++]=l;
          } else {
    		  was[l]=1;
            if(pos[l]==E) {
              add_mov(&quiet,&cquiet,l);
              cnt_mov++;
            } else if(pos[l]&1) {
              add_mov(&vets,&cvets,l);
            } else {
              add_mov(&legs,&clegs,l);
            }
          }
        }
      }
    }
    prv=nxt; q_old=q_new;
  } while(q_old);
}




void dfs(int k) {
  int i;

  was[k]=1;

  for(i=0;i<4;i++) {
    int l=k+del[i];
    if(pos[l]!=F && !was[l]) {
      if((pos[l]>>1)==col) {
        dfs(l);
      } else {
        cnt_mov++; was[l]=1;
        if(pos[l]==E) {
          add_mov(&quiet,&cquiet,l);
        } else if(pos[l]&1) {
          add_mov(&vets,&cvets,l);
        } else {
          add_mov(&legs,&clegs,l);
        }
      }
    }
  }
}


inline void gen_moves(void) {
  memset(was,0,sizeof(was));
  cnt_mov=0; used=0;
  vets=0; legs=0; quiet=0;
  cvets=vets; clegs=legs; cquiet=quiet;
  int k=city[col];
  if(pos[k]==E) {
    add_mov(&quiet,&cquiet,k);
  } else {
/*    if((rand()%7)==1)
	  wav(k);
	else */
		dfs(k);
  }

  if(cvets) cvets->next=quiet;
  if(clegs) clegs->next=vets;

  if(legs) moves=legs;
  else if(vets) moves=vets;
  else moves=quiet;
}

int z;
int ans[10][2];

int make_simple_mov(int k) {
  int i,res;
  if(pos[k]==E) {
    res=1;
  } else if(pos[k]&1) {
    res=3;
  } else res=2;
  was[k]=1;
  for(i=0;i<4;i++) {
    int l=k+del[i];
    if(pos[l]!=F && !was[l]) {
		was[l]=1;
      if((pos[l]>>1)==col) {

      } else {
        if(pos[l]==E) {
          add_mov(&quiet,&cquiet,l);
		  cnt_mov++;
        } else if(pos[l]&1) {
          add_mov(&vets,&cvets,l);
        } else {
          add_mov(&legs,&clegs,l);
        }
      }
    }
  }

  ans[z][0]=k; ans[z++][1]=res;

  return res;
}

int search(int depth,int alpha,int beta) {
  
  if(!depth) {
    return pos_val[col]-pos_val[op_col];
  }

  gen_moves();

  int cnt=5;

  for(int i=0;i<5 && cnt>0;i++) {
    _list **tmp;

    if(cnt==3 && (!quiet || rand()%4>0) && vets) {
      cnt-=make_simple_mov(vets->x);
      continue;
    }
    
    if(cnt>=2)
	  tmp=&legs;
	else tmp=&quiet;
    if(!*tmp && cnt>=3) tmp=&vets;
    if(!*tmp) tmp=&quiet;
	if(!*tmp) break;
/*	_list *zquiet;
	if(tmp==&quiet) {
	  int k=rand()%cnt_mov;
	  zquiet=quiet;
	  for(;k;k--) {
		zquiet=zquiet->next;
	  }
		tmp=&zquiet;
	  cnt_mov--;
	}*/
    cnt-=make_simple_mov((*tmp)->x);
    (*tmp)=(*tmp)->next;
  }


}




int main(void) {
  int n,m,k,l,i,j; char str[5];

#ifdef _DEBUG
  freopen("input.txt","r",stdin);
#endif
  
  if(scanf("%d",&col)<=0) {
    printf("S.P.Q.R.\n");
    return 0;
  }
  
//  srand(GetTickCount());

  srand((unsigned)time( NULL ));

  op_col=col^1;

  scanf("%d",&N);
  del[0]=-1; del[1]=1; del[2]=N+2; del[3]=-N-2;

  memset(pos,F,sizeof(pos));

  for(k=0;k<2;k++) {
    scanf("%d%d",&i,&j);
    city[k]=(i+1)*(N+2)+j+1;
  }

  if(city[col]==N+3) {
    del[0]=1; del[1]=-1; del[2]=-N-2; del[3]=N+2;
    
  }

  for(i=1;i<=N;i++) for(j=1;j<=N;j++) {
    k=i*(N+2)+j;
    scanf("%s",&str);
    if(str[0]=='.') pos[k]=E;
    else {
      if(str[0]=='n' || str[0]=='N') {
        pos[k]=(str[1]-'0')*2;
      } else {
        pos[k]=(str[1]-'0')*2+1;
      }
    }
  }

  z=0;
  search(10,0,0);
  for(i=0;i<z;i++)
    printf("%d %d %d\n",ans[i][0]%(N+2)-1,ans[i][0]/(N+2)-1,ans[i][1]);

  return 0;
}
