(*------------------------------------------------------------
TEAM25
A
175
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
program DY_Game;
{$APPTYPE CONSOLE}
const
   MAX = 17;

type
   TField = record
      State: longint;
      Dist: array [0..4] of longint;
   end;

   TStep = record
      x,y,Num: longint;
   end;

var
   a: array [0..MAX-1,0..MAX-1] of TField;
   Step: array [1..5] of TStep;

   Color,n,xx1,yy1,xx2,yy2,i1,i2,b1,b2,b3,Rest,SCnt: longint;
   ch1,ch2: char;
   IsInvert: boolean;

procedure Invert(var x,y: longint);
begin
   x:=n-x-1; y:=n-y-1;
end;

function IsInField(const x,y: longint): boolean;
begin
   Result:=(x>=0) AND (x<n) AND (y>=0) AND (y<n);
end;

procedure BFS(const xx,yy,Slot: longint);
var
   p1,p2,QCnt,QCrr,Color: longint;
   U: array [0..MAX-1,0..MAX-1] of boolean;
   Q: array [0..MAX*MAX] of record
                               x,y: longint;
                            end;
{
function IsInQ(const x,y: longint): boolean;
begin
   Result:=U[x,y];
end;
}
procedure AddToQ(const x,y,Dist: longint);
begin
   inc(QCnt); Q[QCnt].x:=x; Q[QCnt].y:=y; a[x,y].Dist[Slot]:=Dist; U[x,y]:=true;
end;

procedure TryToAdd(const x,dx,y,dy: longint);
begin
   if (IsInField(x+dx,y+dy)) AND NOT (U[x+dx,y+dy]) AND (a[x+dx,y+dy].State div 10 = a[x,y].State div 10) then
      AddToQ(x+dx,y+dy,a[x,y].Dist[Slot]+1);
end;

begin
   // init
   for p1:=0 to n-1 do for p2:=0 to n-1 do
      a[p1,p2].Dist[Slot]:=-1;

   //Color:=a[xx,yy].State div 10;

   FillChar(U,SizeOf(U),false);
   QCnt:=-1; AddToQ(xx,yy,0); QCrr:=0; Q[0].x:=xx; Q[0].y:=yy;
   // bfs
   while QCrr<=QCnt do
      begin
         TryToAdd(Q[QCrr].x,-1,Q[QCrr].y, 0);
         TryToAdd(Q[QCrr].x,+1,Q[QCrr].y, 0);
         TryToAdd(Q[QCrr].x, 0,Q[QCrr].y,-1);
         TryToAdd(Q[QCrr].x, 0,Q[QCrr].y,+1);

         inc(QCrr);
      end;
end;

procedure AddStep(const x,y,Mode: longint);
begin
   //if x<0 then Writeln(ErrOutput,'fuck x');
   //if y<0 then Writeln(ErrOutput,'fuck y');
   if Rest>=Mode then
      begin
         inc(SCnt);
         Step[SCnt].Num:=Mode;
         Step[SCnt].x:=x;
         Step[SCnt].y:=y; dec(Rest,Mode);

         //if S[SCnt].x<0 then Writeln(ErrOutput,'fuck x');
         //if S[SCnt].y<0 then Writeln(ErrOutput,'fuck y');

         // re bfs
         BFS(0,0,0);
      end;
end;

function IsNear(const x,y,Slot: longint): boolean;
begin
   Result:=(a[x,y].Dist[Slot]>=0) OR
           (IsInField(x-1,y  )) AND (a[x-1,y  ].Dist[Slot]>=0) OR
           (IsInField(x+1,y  )) AND (a[x+1,y  ].Dist[Slot]>=0) OR
           (IsInField(x  ,y+1)) AND (a[x  ,y+1].Dist[Slot]>=0) OR
           (IsInField(x  ,y-1)) AND (a[x  ,y-1].Dist[Slot]>=0);
end;

begin
   // input ====================================================================

   // name
   if SeekEOF then
      begin Writeln('Maydan conqueror'); exit; end;

   // base
   Readln(Color);
   //Writeln(ErrOutput,Color);
   Readln(n);
   //Writeln(ErrOutput,n);
   Readln(xx1,yy1);
   Writeln(ErrOutput,xx1,' ',yy1);
   Readln(xx2,yy2);
   Writeln(ErrOutput,xx2,' ',yy2);
   // invert mark
   IsInvert:=((xx1<>0) OR (yy1<>0)) AND (Color=0) OR ((xx1<>n-1) OR (yy1<>n-1)) AND (Color=1);
   // read field
   for i1:=0 to n-1 do
      begin
         for i2:=0 to n-1 do
            begin
               Read(ch1,ch2); //Write(ErrOutput,ch1,ch2);
               // perform
               if ch1<>'.' then
                  begin
                     case ch1 of
                        'n','N': begin
                                    if ch2=chr(Color+48) then b1:=11 // my novice
                                                         else b1:=21; // enemy's novice
                                 end;
                        'v','V': begin
                                    if ch2=chr(Color+48) then b1:=12 // my veteran
                                                         else b1:=22; // enemy's veteran
                                 end;
                     end;
                     // next
                     if NOT (EOF) then begin Read(ch1); {Write(ErrOutput,ch1);} end;
                  end
               else b1:=0; // free
               // normalize
               b2:=i1; b3:=i2;
               if IsInvert then Invert(b2,b3);
               a[b2,b3].State:=b1;
            end;
         Readln; //Writeln(ErrOutput);
      end;

   // solve ====================================================================

   //Writeln(ErrOutput,'Started');
   if IsInvert then Writeln(ErrOutput,'invert') else Writeln(ErrOutput,'no invert');
   Rest:=5; SCnt:=0;

   BFS(0,0,0);
   {
   // run through diagonals
   for i1:=0 to n-1 do
      begin
         for i2:=0 to i1+1 do
            begin
               b1:=i1-i2; b2:=i2;
               case a[b1,b2].State of
                  0: AddStep(i1,i2,1);
                  21: AddStep(i1,i2,2);
                  22: AddStep(i1,i2,3);
               end;
            end;
      end;
   }

   // first half
   for i1:=0 to n-1 do
      begin
         for i2:=0 to i1 do if (IsNear(i1-i2,i2,0)) AND (a[i1-i2,i2].State=22) then AddStep(i1-i2,i2,3);
         for i2:=0 to i1 do if (IsNear(i1-i2,i2,0)) AND (a[i1-i2,i2].State=21) then AddStep(i1-i2,i2,2);
         for i2:=0 to i1 do if (IsNear(i1-i2,i2,0)) AND (a[i1-i2,i2].State= 0) then AddStep(i1-i2,i2,1);
      end;

   // advanced migration
   for i1:=1 to n-1 do
      begin
         for i2:=n-1 downto i1 do if (IsNear(n-1-i2+i1,i2,0)) AND (a[n-1-i2+i1,i2].State=22) then AddStep(n-1-i2+i1,i2,3);
         for i2:=n-1 downto i1 do if (IsNear(n-1-i2+i1,i2,0)) AND (a[n-1-i2+i1,i2].State=21) then AddStep(n-1-i2+i1,i2,2);
         for i2:=n-1 downto i1 do if (IsNear(n-1-i2+i1,i2,0)) AND (a[n-1-i2+i1,i2].State= 0) then AddStep(n-1-i2+i1,i2,1);
      end;
   
   //Writeln(ErrOutput,'SCnt = ',SCnt);

   // output
   for i1:=1 to SCnt do
      begin
         b1:=Step[i1].x; b2:=Step[i1].y; //if b1<0 then Writeln(ErrOutput,'fuck');
         if IsInvert then Invert(b1,b2);
         Writeln(ErrOutput,b2,' ',b1,' ',Step[i1].Num);
         Writeln(b2,' ',b1,' ',Step[i1].Num);

      end;

   {
   for i1:=0 to MAX-1 do
      begin
         for i2:=0 to MAX-1 do
            begin
               b1:=i1; b2:=i2;
               if IsInvert then Invert(b1,b2);
               Write(a[b1,b2].State,' ');
            end;
         Writeln;
      end;
   }
   //if SCnt=1 then
   //   begin
   //      Writeln('0 0 1');
   //      Writeln('1 0 1');
   //   end;
end.
