/*------------------------------------------------------------
TEAM19
A
178
Target: LegionMSVC6; Platform: Win32; Comment: MS Visual C++ 6 (Legionaries)
------------------------------------------------------------*/
#include	<stdio.h>

#define fprintf

int P;
int n;

int X[2], Y[2];

struct Cell {
	int who;
	bool vet;
	bool con;
	Cell (int who = -1, bool vet = false, bool con = false) 
		: who (who), vet (vet), con (con) {}
};

const int MN = 100;

Cell F[MN][MN];

void inp ()
{
	for (int i = 0; i < n; ++i)
	for (int j = 0; j < n; ++j)
	{
		char bu[10];
		scanf ("%s", bu);
		if (bu[0] != '.')
			F[i][j] = Cell (
				bu[1] == '1', 
				bu[0] == 'V' || bu[0] == 'v', 
				bu[0] == 'V' || bu[0] == 'N'
			);
	}
}
bool CG[MN][MN];
int mn[MN][MN];

bool Q[MN][MN];

void eat (int ii, int jj)
{
	F[ii][jj].who = P;
	F[ii][jj].con = true;
	F[ii][jj].vet = true;
	int i, j;
	for (i = 0; i < n; ++i)
	for (j = 0; j < n; ++j)
	if (F[i][j].who != P)
	{
		bool can = false;
		for (int di = -1; di <= 1; ++di)
		for (int dj = -1; dj <= 1; ++dj)
 		if (di || dj)
		if (!di || !dj)
		{
			int ii = i + di;
			int jj = j + dj;
			if (ii >= 0 && ii < n && jj >= 0 && jj < n)
			if (F[ii][jj].who == P && F[ii][jj].con)
			{
				can = true;
				break;
			}
		}
		CG[i][j] = can;
		if (can)
		{
			if (F[i][j].who == -1)
				mn[i][j] = 1;
			else if (F[i][j].vet)
				mn[i][j] = 3;
			else
				mn[i][j] = 2;
		}
	}
}

void outp ()
{
	for (int i = n-1; i >=0; --i)
 	{
		for (int j = 0; j < n; ++j)
		if (F[i][j].who == -1)             	
			fprintf (stderr, ".__");
		else
			fprintf (stderr, "%c%d_", 
					"nNvV"[F[i][j].vet*2 + F[i][j].con], 
					F[i][j].who);
		fprintf (stderr, "\n");
	}
}


void solve ()
{
	scanf ("%d", &n);	
	scanf ("%d%d%d%d", &X[0], &Y[0], &X[1], &Y[1]);
	inp ();
	outp ();
	int k = 5;
	int i, j;
	for (i = 0; i < n; ++i)
	for (j = 0; j < n; ++j)
	if (F[i][j].who != P)
	{
		bool can = false;
		for (int di = -1; di <= 1; ++di)
		for (int dj = -1; dj <= 1; ++dj)
 		if (di || dj)
		if (!di || !dj)
		{
			int ii = i + di;
			int jj = j + dj;
			if (ii >= 0 && ii < n && jj >= 0 && jj < n)
			if (F[ii][jj].who == P && F[ii][jj].con)
			{
				can = true;
				break;
			}
		}
		CG[i][j] = can;
		if (can)
		{
			if (F[i][j].who == -1)
				mn[i][j] = 1;
			else if (F[i][j].vet)
				mn[i][j] = 3;
			else
				mn[i][j] = 2;
		}
	}

	for (int t = 0; t < 2; ++t)
	{
		if (P == 0 || t)
	for (i = 3; i >= 0; --i)
	for (j = 3; j >= 0; --j)
 	if (i != 3 || j == 0)
	if (j != 3 || i == 0)
	if (!Q[i][j])
	if (CG[i][j])
	if (mn[i][j] <= k)
	{
		k -= mn[i][j];
		Q[i][j] = true;
		eat (i, j);
		printf ("%d %d %d\n", j, i, mn[i][j]);
		fprintf (stderr, "%d %d %d\n", j, i, mn[i][j]);
	}
	for (i =n-4; i < n; ++i)
	for (j = n-4; j < n; ++j)
	if (!Q[i][j])
	if (CG[i][j])
	if (mn[i][j] <= k)
	{
		k -= mn[i][j];
		Q[i][j] = true;
		eat (i, j);
		printf ("%d %d %d\n", j, i, mn[i][j]);
		fprintf (stderr, "%d %d %d\n", j, i, mn[i][j]);
	}
	}

//	for (i = 0; i < n; ++i)
//	for (j = 0; j < n; ++j)
//for (int w = 3; w <= 9; ++w)
	int i0 = F[0][0].who == P ? 0 : n - 1;
	int di = F[0][0].who == P ? 1 : -1;
	int j0 = F[0][0].who == P ? 0 : n - 1;
	int dj = F[0][0].who == P ? 1 : -1;
	for (i = i0; i >= 0 && i < n; i += di)
	for (j = j0; j >= 0 && j < n; j += dj)
	if (i == 0 || j == n - 1)
//	for (j = i - w; j <= i + w; ++j)
	if (!Q[i][j])
	if (i >= 0 && i < n)
	if (j >= 0 && j < n)
	if (CG[i][j])
	if (mn[i][j] <= k)
	{
		k -= mn[i][j];
		Q[i][j] = true;
		eat (i, j);
		printf ("%d %d %d\n", j, i, mn[i][j]);
		fprintf (stderr, "%d %d %d\n", j, i, mn[i][j]);
	}
	for (i = 0; i < n; ++i)
	for (j = 0; j < n; ++j)
	if (!Q[i][j])
	if (CG[i][j])
	if (mn[i][j] <= k)
	{
		k -= mn[i][j];
		Q[i][j] = true;
		eat (i, j);
		printf ("%d %d %d\n", j, i, mn[i][j]);
		fprintf (stderr, "%d %d %d\n", j, i, mn[i][j]);
	}
	
	fprintf (stderr, "k=%d", k);
//	printf ("0 1 -1\n1 0 5");
}

int main ()
{                
	if (scanf ("%d", &P) != 1)
 		printf ("Tramvaj");
	else
		solve ();
	return 0;
}
