(*------------------------------------------------------------
TEAM44
A
147
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
{$O-}
program Legions.Bot;
uses SysUtils, Math;
const
	//   !
	PLAYER_NAME = ' chtulhu :-E ';
	MAX_SIZE = 100;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;
	
	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	lastx,lasty: Integer;
	me: Integer;
	he: Integer;
	size: Integer;
	n: Integer;  
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
  he:=1-me;
	Readln(size);
	for i := 0 to 1 do
	Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;
	
//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;
	
procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;

procedure Move();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

var
	p: TPoint;
	ind: Integer;
begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

procedure eat; 
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y) then
        if (map[x,y].owner=he)
         and (not map[x,y].isVeteran) then  
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

var
	p: TPoint;
	ind: Integer;
begin
  if  legionsCount <2 then begin
    Move;exit;

  end;
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then  begin Move; exit; end;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
  Move;
end;

procedure mov2;
var
i1,j1,cou,i,j:longint;
d:array[0..MAX_SIZE,0..MAX_SIZE] of longint;
pr:array[0..MAX_SIZE,0..MAX_SIZE] of longint;
lp,lx,ly:array[0..MAX_SIZE*MAX_SIZE] of longint;
bx,by,v:array[0..MAX_SIZE,0..MAX_SIZE] of longint;
ncx,ncy,cx,cy,k,nd,dd,miny,minx,imp,min:longint;
begin
 imp:=10000;
 for i:=0 to n-1 do for j:=0 to n-1 do d[i][j]:=imp;

   for i:=0 to n-1 do for j:=0 to n-1 do v[i][j]:=0;
     for i:=0 to n-1 do for j:=0 to n-1 do pr[i][j]:=0;
    for i:=0 to n-1 do for j:=0 to n-1 do bx[i][j]:=city[me].x;
    for i:=0 to n-1 do for j:=0 to n-1 do by[i][j]:=city[me].y;
 d[city[me].x,city[me].y]:=0;
 v[city[me].x,city[me].y]:=0;
 //dijk begin
 while true do begin
  min:=100000;
  minx:=-1;miny:=-1;
  for i:=0 to n-1 do for j:=0 to n-1 do
    if (v[i][j]=0) and (d[i][j]<min)
    then begin
     min:=d[i][j];minx:=i;miny:=j;
     end;
    if (v[i][j]=0) and (d[i][j]=min)
    then begin
     if random(2)=1 then begin
     min:=d[i][j];minx:=i;miny:=j;
      end;
     end;

     i:=min;
  if (minx=city[he].x)and(miny=city[he].y) then
    begin
    //found
     break;
     //found;

    end;
    v[minx][miny]:=1;
  for i1:=0 to 1 do for j1:=0 to 1 do
   begin
       if (i1=0) and (j1=0) then begin i:=minx+1;j:=miny;end;
       if (i1=0) and (j1=1) then begin i:=minx-1;j:=miny;end;
       if (i1=1) and (j1=0) then begin i:=minx;j:=miny+1;end;
       if (i1=1) and (j1=1) then begin i:=minx;j:=miny-1;end;

       if(i<0) then continue;
       if(j<0) then continue;
       if(i>n-1) then continue;
       if(j>n-1) then continue;
       if v[i][j]=1 then continue;
    if (map[i][j].owner= me) then dd:=0
    else if (map[i][j].owner= -1) then dd:=1
    else if map[i][j].isVeteran then dd:=3
    else dd:=2;
    nd:=dd+d[minx][miny];
    if (nd<d[i][j]) or((nd=d[i][j]) and (map[minx][miny].owner=he )) then begin
       d[i][j]:=nd;
       //v[i][j]:=1;
       bx[i][j]:=minx;
       by[i][j]:=miny;
       pr[i][j]:=dd;
     end;

   end;

  end;
   //dijk end;
   //reverse hodi
   cx:=city[he].x;
   cy:=city[he].y;
   k:=0;
   while (cx<>city[me].x) or (cy<>city[me].y) do begin
    k:=k+1;
    lx[k]:=cx;ly[k]:=cy;
    lp[k]:=pr[cx][cy];    
    ncx:=bx[cx][cy];
    ncy:=by[cx][cy];
    cx:=ncx;cy:=ncy;
   end;
//   if random(2)=1 then begin eat;exit;end;
   cou:=5;
   lastx:=-1;
   while (cou>0) and (k>0) do begin
    if (lp[k]>0) then begin
       if cou>=lp[k] then begin
         cou:=cou-lp[k];
         lastx:=lx[k];
         lasty:=ly[k];         
         MoveTo(lx[k],ly[k]);

       end
       else begin
       //finish
       cou:=0;
//       Move;
       eat;

       end;


     end;
     k:=k-1;


   end;
   eat;

   if(cou>0) then eat;


   



end;

begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
    n:=size;
//    if random(2)=1 then
//      mov2()
//      else move();
///		Move();
//eat()
	Mov2();
	end;
end.
